<template>
	<div style="height:100%">
		<slot v-if="mode=='custom'"  :context="context"/>
		<el-row wrap v-if="mode=='raw'">
			<el-col :xs="24"  >
				<el-input autosize spellcheck="false" type="textarea" rows="15" v-model="contextRaw"></el-input>
			</el-col>
		</el-row>
		<el-table row-class-name="dialplan-exten-row" :show-header="false" v-if="mode=='table'" :highlight-current-row="false" :data="contextArray">
			<el-table-column  width="200"  label="Propiedad" >
				<template v-slot="{row}">
					<span v-if="readonly">{{row.var}}</span>
					<!-- <el-input v-else v-model="row.var" size="mini" /> -->
				</template>
			</el-table-column>
			<el-table-column  prop="value" label="Valor" >
				<template v-slot="{row}">
					<span v-if="readonly">{{row.value}}</span>
					<!-- <el-input v-else v-model="row.value" size="mini" /> -->
				</template>
			</el-table-column>
		</el-table>
	</div>
</template>
<script>

export default {
	props: {
		value: Array,
		showGeneratedFields: {
			type: Boolean,
			default: false
		},
		/**
		 * Modo de visualización:
		 * 	- custom: muestra el contenido del slot (para formularios personalizados)
		 *  - table: 	muestra una tabla con todos los elementos del contexto
		 *  - raw:		muestra el contenido en un textarea editable
		 */
		mode: {
			type: String,
			default: "table"
		},
		mnemonics: {
			type: Array,
			default() {
				return []
			}
		},
		readonly: Boolean,

	},
	watch:{
		value:{
			handler(v) {
				this.stopPropagation = true
				this.context =  this.parseContext(v)
			}
		},
		context:{
			deep:true,
			handler(v) {
				if(this.stopPropagation) {
					this.stopPropagation = false
					return
				}

				const contextData = this.generateContext(v)
				this.$emit("input",contextData)
			}
		},
	},
	computed: {
		contextRaw: {
			get() {
				return this.value.join('\n')
			},
			set(v) {
				this.$emit("input",v.split('\n'))
			}
		},
		contextArray() {
			let res = []
			if(!this.value) {
				return res
			}
			for (const linea of this.value) {
				const partes = linea.split(/=>?/i)
				if(partes.length < 2) {
					continue
				}
				const v = partes.shift().trim()
				const value = partes.join('=').trim()
				//const value = partes.join('=')
				res.push({
					var: v,
					value: value
				})
			}
			return res
		}
		
	},
	methods: {
		parseContext(data) {
			let res = {}
			if(!data) {
				return res
			}
			for (const linea of data) {
				const partes = linea.split(/=>?/i)
				if(partes.length < 2) {
					continue
				}
				const v = partes.shift().trim()
				//const value = partes.join('=').trim()
				const value = partes.join('=')

				// const value = partes[1] //.trim()
				if(res[v]) {
					if(!Array.isArray(res[v])) {
						res[v] = [res[v]]
					}
						res[v].push(value)
				} else {
					res[v] = value
				}
			}

			return res
		},
		generateContext(data) {
			let res = []
			for(const c of Object.keys(data)) {
				const value = Array.isArray(data[c]) ? data[c] : data[c].split(/[\n,]/i)
				for(const i of value) {
					res.push(`${c}=${i}`)
				}
			}
			return res
		},
	},
	data() {
		return {
			stopPropagation: false,
			context: {},
		}
	}
	
}
</script>
<style lang="css" >
 .el-textarea {
	font-family:monospace
 }
 .dialplan-exten-row td {
		padding: 2px 0
 }
</style>